class UserProfile {
  bool? success;
  String? message;
  MyData? myData;

  UserProfile({this.success, this.message, this.myData});

  factory UserProfile.fromJson(Map<String, dynamic> json) {
    return UserProfile(
      success: json['success'],
      message: json['message'],
      myData: json['myData'] != null ? MyData.fromJson(json['myData']) : null,
    );
  }
}

class MyData {
  String? id;
  String? designation;
  String? name;
  String? email;
  String? mobileNumber;
  String? principalDistributer;
  String? addedBy;
  String? userType;
  String? kyc;
  String? fcmToken;
  String? createdAt;
  String? updatedAt;
  String? mappedSC;
  String? uniqueId;
  int? v;

  MyData(
      {this.id,
        this.designation,
        this.name,
        this.email,
        this.mobileNumber,
        this.principalDistributer,
        this.addedBy,
        this.userType,
        this.kyc,
        this.fcmToken,
        this.createdAt,
        this.updatedAt,
        this.mappedSC,
        this.uniqueId,
        this.v});

  factory MyData.fromJson(Map<String, dynamic> json) {
    return MyData(
      id: json['_id'],
      designation: json['designation'],
      name: json['name'],
      email: json['email'],
      mobileNumber: json['mobile_number'],
      principalDistributer: json['principal_distributer'],
      addedBy: json['addedBy'],
      userType: json['userType'],
      kyc: json['kyc'],
      fcmToken: json['fcm_token'],
      createdAt: json['createdAt'],
      updatedAt: json['updatedAt'],
      mappedSC: json['mappedSC'],
      uniqueId: json['uniqueId'],
      v: json['__v'],
    );
  }
}