// import 'package:cheminova/controller/home_controller.dart';
// import 'package:cheminova/widgets/my_drawer.dart';
// import 'package:flutter/cupertino.dart';
// import 'package:flutter/material.dart';
//
// import '../widgets/comman_background.dart';
// import '../widgets/common_appbar.dart';
//
// class ProfileScreen extends StatelessWidget {
//   const ProfileScreen({Key? key}) : super(key: key);
//
//   @override
//   Widget build(BuildContext context) {
//     return Stack(
//       children: [
//         CommonBackground(
//           isFullWidth: true,
//           child: Scaffold(
//             drawer: const MyDrawer(),
//             backgroundColor: Colors.transparent,
//             appBar: CommonAppBar(
//               title: const Text('Profile'),
//               backgroundColor: Colors.transparent,
//               elevation: 0,
//               actions: [
//                 IconButton(
//                   onPressed: () {
//                     Navigator.pop(context);
//                   },
//                   icon: Image.asset('assets/Back_attendance.png'),
//                   padding: const EdgeInsets.only(right: 20),
//                 ),
//               ],
//             ),
//             body: Consumer<HomeController>(
//               builder: (context, profileProvider, child) {
//                 final profileData = profileProvider.profileResponse?.myData!;
//                 return SingleChildScrollView(
//                   child: Column(
//                     children: [
//                       Container(
//                         padding: const EdgeInsets.all(20.0).copyWith(top: 15, bottom: 30),
//                         margin: const EdgeInsets.symmetric(horizontal: 30.0, vertical: 20.0),
//                         decoration: BoxDecoration(
//                           border: Border.all(color: Colors.white),
//                           color: const Color(0xffB4D1E5).withOpacity(0.9),
//                           borderRadius: BorderRadius.circular(26.0),
//                         ),
//                         child: Column(
//                           crossAxisAlignment: CrossAxisAlignment.start,
//                           children: [
//                             SizedBox(height: 20),
//                             _buildProfileItem('Name', profileData?.name ?? ''),
//                             _buildProfileItem('ID', profileData?.uniqueId ?? ''),
//                             _buildProfileItem('Email ID', profileData?.email ?? ''),
//                             _buildProfileItem('Mobile Number', profileData?.mobileNumber ?? ''),
//                             _buildProfileItem('Designation', profileData?.designation ?? ''),
//                           ],
//                         ),
//                       ),
//                     ],
//                   ),
//                 );
//               },
//             ),
//           ),
//         ),
//       ],
//     );
//   }
//
//   Widget _buildProfileItem(String label, String value) {
//     return Padding(
//       padding: const EdgeInsets.symmetric(vertical: 10),
//       child: Column(
//         crossAxisAlignment: CrossAxisAlignment.start,
//         children: [
//           Text(
//             label,
//             style: const TextStyle(
//               fontSize: 16,
//               fontWeight: FontWeight.bold,
//               color: Color(0xff004791),
//             ),
//           ),
//           const SizedBox(height: 5),
//           Text(
//             value,
//             style: const TextStyle(
//               fontSize: 18,
//               color: Colors.black,
//             ),
//           ),
//           const Divider(color: Colors.grey),
//         ],
//       ),
//     );
//   }
// }